//Version 0.1


import java.awt.BorderLayout;
import java.awt.GridLayout;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class CorrelationTable extends JPanel
{

	private static final long serialVersionUID = 1L;
	JTextField[][] table;
	int nbVar;
	VariablesNames varNamesPanel;
	CopulaLine copula;
	public CorrelationTable()
	{

	}

	public CorrelationTable(int innbVar,	VariablesNames varNamesPanelin)
	{
		varNamesPanel = varNamesPanelin;

		nbVar=innbVar;
		table = new JTextField[nbVar][nbVar];
		JPanel tablePanel = new JPanel();
		this.setLayout(new BorderLayout());
		tablePanel.setLayout(new GridLayout(nbVar+1,nbVar+1));
		copula = new CopulaLine();

		for(int ii=0;ii<nbVar;ii++)
		{
			for(int ij=0;ij<nbVar;ij++)
			{
				table[ii][ij] = new JFormattedTextField();
				table[ii][ij].setColumns(5);
				table[ii][ij].setText("0");
				if(ii==ij)
				{
					table[ii][ij].setText("1");
					table[ii][ij].setEditable(false);
				}
				if(ii>ij)
				{
					table[ii][ij].setText(" ");
					table[ii][ij].setEditable(false);
				}
			}

		}

		tablePanel.add( new JLabel(" "));
		for(int ii=0;ii<nbVar;ii++)
			tablePanel.add( new JLabel(varNamesPanel.getName(ii)));

		for(int ii=0;ii<nbVar;ii++)
		{
			tablePanel.add( new JLabel(varNamesPanel.getName(ii)));
			for(int ij=0;ij<nbVar;ij++)
			{
				tablePanel.add(table[ii][ij]);
			}
		}
		
		this.add(tablePanel,BorderLayout.CENTER);
		this.add(copula,BorderLayout.SOUTH);


	}

	public void setType(int i) {
		copula.setType(i);
	}
	public void setType(int i,String s) {
		copula.setType(i, s);		
	}

	public String getField(int ii, int ij)
	{
		return (table[ii][ij].getText());
	}
	
	public void setField(int ii, int ij,String s )
	{
		table[ii][ij].setText(s);
	}
	
	public String getParam(int i)
	{
		return (copula.getField(i));
	}
	public void setParam(int i,String s)
	{
		copula.setField(i,s);
	}
	public String getType()
	{
		String res = null;
		if(copula.getType()==0)
			res = "Gaussian";
		if(copula.getType()==1)
			res = "Student";
		
		return(res);
	}
	public int getTypeIndex()
	{
		return(copula.getType());
	}
	

}
