//Version 0.1

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DistribLine extends JPanel implements ActionListener 
{

	private static final long serialVersionUID = 1L;
	JLabel name;
	JComboBox distrib;
	JTextField[] parameters;

	static int[] nbParam  = { 1,2,2,1,1,2,2,2,4,2,2,3,3,2,2,3,2,2,2,2/*,2*/};
	static String[] choice = { 
	 "Bernoulli (Prob. of success)"
	,"Beta (Mean, StdDev)"
	,"Beta (Shape1, Shape2)"
	,"Chi-Squared (No. of degrees of freedom)"
	,"Exponential (Mean)"
	,"Gamma (Mean, StdDev)"
	,"Gamma (Shape, Scale)"
	,"Gaussian (Mean, StdDev)"
	,"Gaussian -- Truncated (Mean, StdDev, Left Endpoint, Right Endpoint)"
	,"Rectangular (Mean, StdDev)"
	,"Rectangular (Left Endpoint, Right Endpoint)"
	,"Student t (Mean, StdDev, No. of degrees of freedom)"
	,"Student t (Center, Scale, No. of degrees of freedom)"
	,"Triangular -- Symmetric (Mean, StdDev)"
	,"Triangular -- Symmetric (Left Endpoint, Right Endpoint)"
	,"Triangular -- Asymmetric (Left Endpoint, Mode, Right Endpoint)"
	,"Uniform (Mean, StdDev)"
	,"Uniform (Left Endpoint, Right Endpoint)"
	,"Weibull (Mean, StdDev)"
	,"Weibull (Shape, Scale)"
	/*,"von Mises (Mean, Concentration)"*/
	};
	
	public DistribLine()
	{

	}
	public int getType() {

		return distrib.getSelectedIndex();
	}
	public void setType(int i) {

		distrib.setSelectedIndex(i);
	}
	public DistribLine(String inName)
	{
		name = new JLabel(inName);

		
		distrib = new JComboBox(choice);
		distrib.addActionListener(this);
		parameters = new JTextField[1];

		for(int ii=0;ii<parameters.length;ii++)
		{
			parameters[ii] = new JFormattedTextField();
			parameters[ii].setColumns(7);
			parameters[ii].setText("1");

		}
		setDefault();


		this.add(name);
		this.add(distrib);
		for(int ii=0;ii<parameters.length;ii++)
		{
			this.add(parameters[ii]);
		}
		distrib.setSelectedIndex(7);
	}
	public int getNb()
	{
		return (parameters.length);
	}


	public String getField(int il)
	{
		return (parameters[il].getText().trim());
	}
	public void setField(int il,String s)
	{
		parameters[il].setText(s);
	}

	public void changeName(String newName)
	{
		name.setText(newName);
		this.updateUI();	
	}


	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == distrib) {
			int wantedParam=nbParam[distrib.getSelectedIndex()];
			
			this.removeAll();
			this.add(name);
			this.add(distrib);
			parameters = new JTextField[wantedParam];

			for(int ii=0;ii<wantedParam;ii++)
			{
				parameters[ii] = new JFormattedTextField();
				parameters[ii].setColumns(7);
				parameters[ii].setText("1");
				
				this.add(parameters[ii]);
			}
			setDefault();
			this.updateUI();


		}
	}
	private void setDefault()
	{
		int typeDist = getType();
		
		if(typeDist==0)  // Bernoulli (Prob. of success)
		{
			parameters[0].setText("0.5");
		}
		if(typeDist==1)  // Beta (Mean, StdDev)
		{
			parameters[0].setText("0.5");
			parameters[1].setText("0.2");			
		}
		if(typeDist==2) // Beta (Shape1, Shape2)
		{
			
		}
		if(typeDist==3) // Chi-Squared (DF)
		{
			
		}
		if(typeDist==4) // Exponential (Mean)
		{
			
		}
		if(typeDist==5) // Gamma (Mean, StdDev)
		{

		}
		if(typeDist==6) // Gamma (Shape, Scale)
		{
			
		}
		if(typeDist==7) // Gaussian (Mean, StdDev)		
		{
			parameters[0].setText("0");
			parameters[1].setText("1");		
		}
		if(typeDist==8) // Gaussian -- Truncated (Mean, StdDev, Left, Right)
		{
			parameters[0].setText("0");
			parameters[1].setText("1");		
			parameters[2].setText("-1");
			parameters[3].setText("1");		
		}
		if(typeDist==9) // Rectangular -- Continuous (Mean, StdDev) 
		{
			parameters[0].setText("0");
			parameters[1].setText("1");	
		}
		if(typeDist==10) // Rectangular -- Continuous (Left, Right)
		{
			parameters[0].setText("-1");
			parameters[1].setText("1");
		}
		if(typeDist==11) // Student t (Mean, StdDev, DF)
		{
			parameters[0].setText("1");
			parameters[1].setText("1");
			parameters[2].setText("3");
		}
		
		if(typeDist==12) // Student t (Center, Scale, DF) 
		{
			parameters[0].setText("1");
			parameters[1].setText("1");
			parameters[2].setText("2");
		}
		if(typeDist==13) // Triangular -- Symmetric (Mean, StdDev)
		{
			parameters[0].setText("0");
			parameters[1].setText("1");
		}
		
		if(typeDist==14) // Triangular -- Symmetric (Left, Right)				
		{
			parameters[0].setText("-1");
			parameters[1].setText("1");
		}
		if(typeDist==15) // Triangular -- Asymmetric (Left, Mode, Right)
		{
			parameters[0].setText("0");
			parameters[1].setText("0.2");
			parameters[2].setText("1");
		}
		if(typeDist==16) // Uniform -- Continuous (Mean, StdDev)
		{
			parameters[0].setText("0");
			parameters[1].setText("1");	
		}
		if(typeDist==17) // Uniform -- Continuous (Left, Right)
		{
			parameters[0].setText("-1");
			parameters[1].setText("1");
		}
		if(typeDist==18) // Weibull (Mean, StdDev)
		{
			
			
		}
		if(typeDist==19) // Weibull (Shape, Scale)
		{
			
		}
		/*if(typeDist==20) // von Mises (Mean, Concentration)
		{
			
		}*/
		
		
	}
	
//	Method which check the validity of the parameters input by the user
//  Return an empty String if all the parameters are valid or a String describing the error if not
	public String checkPararm()
	{
		int typeDist = getType();
		String isValid = "";
		
		try {
			int nb = nbParam[typeDist];
			double[] par = new double[nb] ;
			for(int ii=0;ii<nb;ii++)
			{
				par[ii] = Double.parseDouble(getField(ii));
			}
			
					
			if(typeDist==0)  // Bernoulli (Prob. of success)
			{			
				if ( par[0] <=0 || par[0] >= 1 )
					isValid = "Probability must be greater than 0 and smaller than 1";
			}
			if(typeDist==1)  // Beta (Mean, StdDev)
			{
				if ( par[0] <= 0  || par[0] >= 1  )
					isValid = "The mean must be greater than 0 and smaller than 1 ";
				if ( par[1] <= 0 || par[1] >= 0.5 )
					isValid = "StdDev must be greater than 0 and smaller than 1/2";
				
			}
			if(typeDist==2) // Beta (Shape1, Shape2)
			{
				if ( par[0] <= 0  || par[1] <= 0)
					isValid = "The two shape parameters must be positive";
			}
			if(typeDist==3) // Chi-Squared (DF)
			{
				if ( par[0] <= 0  )
					isValid = "No. of degrees of freedom must be positive";
			}
			if(typeDist==4) // Exponential (Mean)
			{
				if ( par[0] <= 0  )
					isValid = "The mean must be positive";
			}
			if(typeDist==5) // Gamma (Mean, StdDev)
			{
				if ( par[0] <= 0  )
					isValid = "The mean must be positive";
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			if(typeDist==6) // Gamma (Shape, Scale)
			{
				if ( par[0] <= 0  || par[1] <= 0)
					isValid = "The shape and the scale must be positive";
			}
			if(typeDist==7) // Gaussian (Mean, StdDev)		
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			if(typeDist==8) // Gaussian -- Truncated (Mean, StdDev, Left, Right)
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
				if ( par[2]>=par[3] )
					isValid = "Left must be less than Right";
			}
			if(typeDist==9) // Rectangular -- Continuous (Mean, StdDev) 
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			if(typeDist==10) // Rectangular -- Continuous (Left, Right)
			{
				if ( par[0] >= par[1]  )
					isValid = "Left must be less than Right";
			}
			if(typeDist==11) // Student t (Mean, StdDev, DF)
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
				if ( par[2] <= 2  )
					isValid = "No. of degrees of freedom must be greater than 2";
			}
			if(typeDist==12) // Student t (Center, Scale, DF) 
			{
				if ( par[1] <= 0  )
					isValid = "Scale must be positive";
				if ( par[2] <= 0  )
					isValid = "No. of degrees of freedom must be positive";
			}
			
			if(typeDist==13) // Triangular -- Symmetric (Mean, StdDev)
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			
			if(typeDist==14) // Triangular -- Symmetric (Left, Right)				
			{
				if ( par[0] >= par[1]  )
					isValid = "Left must be less than Right";
			}
			if(typeDist==15) // Triangular -- Asymmetric (Left, Mode, Right)
			{
				if ( par[0] > par[1]  )
					isValid = "Left must be less than or equal to Mode";
				if ( par[1] > par[2]  )
					isValid = "Mode must be less than or equal to Right";
				if ( par[0]  == par[2] )
					isValid = "Left and Right must be different";
			}
			if(typeDist==16) // Uniform -- Continuous (Mean, StdDev)
			{
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			if(typeDist==17) // Uniform -- Continuous (Left, Right)
			{
				if ( par[0] >= par[1]  )
					isValid = "Left must be less than Right";
			}
			if(typeDist==18) // Weibull (Mean, StdDev)
			{	
				if ( par[0] <= 0  )
					isValid = "The mean must be positive";
				if ( par[1] <= 0  )
					isValid = "StdDev must be positive";
			}
			if(typeDist==19) // Weibull (Shape, Scale)
			{
				if ( par[0] <= 0  || par[1] <= 0)
					isValid = "The shape and the scale must be positive";
			}
			/*if(typeDist==20) // von Mises (Mean, Concentration)
			{
				
			}*/
		} catch (NumberFormatException e1) {
			e1.printStackTrace();
			isValid = "One of the number fields is not a valid number";
		}
		return(isValid);
				
		
	}
}

